RESTinio

Classes | Public Types | Static Public Member Functions | Public Attributes | List of all members
restinio::http_field_parsers::transfer_encoding_value_t Struct Reference

Tools for working with the value of Transfer-Encoding HTTP-field. More...

`#include <transfer-encoding.hpp>`

## Classes
struct | transfer_extension_t
| Description of transfer-extension. More...

## Public Types
enum class | known_transfer_coding_t { chunked , compress , deflate , gzip }
| Enumeration for transfer-coding values from RFC7230. More...
using | value_t = variant_t< known_transfer_coding_t, transfer_extension_t >
| Type for one value from Transfer-Encoding HTTP-field. More...
using | value_container_t = std::vector< value_t >

## Static Public Member Functions
static RESTINIO_NODISCARD constexpr known_transfer_coding_t | chunked () noexcept
static RESTINIO_NODISCARD constexpr known_transfer_coding_t | compress () noexcept
static RESTINIO_NODISCARD constexpr known_transfer_coding_t | deflate () noexcept
static RESTINIO_NODISCARD constexpr known_transfer_coding_t | gzip () noexcept
static RESTINIO_NODISCARD auto | make_parser ()
| A factory function for a parser of Transfer-Encoding value. More...
static RESTINIO_NODISCARD expected_t< transfer_encoding_value_t, restinio::easy_parser::parse_error_t > | try_parse (string_view_t what)
| An attempt to parse Transfer-Encoding HTTP-field. More...

## Public Attributes
value_container_t | values

## Detailed Description

Tools for working with the value of Transfer-Encoding HTTP-field.

This struct represents parsed value of HTTP-field Transfer-Encoding (see https://tools.ietf.org/html/rfc7230#section-3.3.1 and https://tools.ietf.org/html/rfc7230#section-4):

    Transfer-Encoding  = 1#transfer-coding
    transfer-coding    = "chunked"
                       / "compress"
                       / "deflate"
                       / ("gzip" | "x-gzip")
                       / transfer-extension
    transfer-extension = token *( OWS ";" OWS transfer-parameter )
    transfer-parameter = token BWS "=" BWS ( token / quoted-string )

Since
  v.0.6.9

Definition at line 48 of file transfer-encoding.hpp.

## Member Typedef Documentation

## ◆ value_container_t

using restinio::http_field_parsers::transfer_encoding_value_t::value_container_t = std::vector< value_t >

Definition at line 96 of file transfer-encoding.hpp.

## ◆ value_t

using restinio::http_field_parsers::transfer_encoding_value_t::value_t = variant_t< known_transfer_coding_t, transfer_extension_t >

Type for one value from Transfer-Encoding HTTP-field.

Definition at line 91 of file transfer-encoding.hpp.

## Member Enumeration Documentation

## ◆ known_transfer_coding_t

enum class restinio::http_field_parsers::transfer_encoding_value_t::known_transfer_coding_t
| strong

Enumeration for transfer-coding values from RFC7230.

Enumerator
chunked |
compress |
deflate |
gzip |

Definition at line 51 of file transfer-encoding.hpp.

## Member Function Documentation

## ◆ chunked()

static RESTINIO_NODISCARD constexpr known_transfer_coding_t restinio::http_field_parsers::transfer_encoding_value_t::chunked | ( |  | ) |
| inline static constexpr noexcept

Definition at line 60 of file transfer-encoding.hpp.

## ◆ compress()

static RESTINIO_NODISCARD constexpr known_transfer_coding_t restinio::http_field_parsers::transfer_encoding_value_t::compress | ( |  | ) |
| inline static constexpr noexcept

Definition at line 64 of file transfer-encoding.hpp.

## ◆ deflate()

static RESTINIO_NODISCARD constexpr known_transfer_coding_t restinio::http_field_parsers::transfer_encoding_value_t::deflate | ( |  | ) |
| inline static constexpr noexcept

Definition at line 68 of file transfer-encoding.hpp.

## ◆ gzip()

static RESTINIO_NODISCARD constexpr known_transfer_coding_t restinio::http_field_parsers::transfer_encoding_value_t::gzip | ( |  | ) |
| inline static constexpr noexcept

Definition at line 72 of file transfer-encoding.hpp.

## ◆ make_parser()

static RESTINIO_NODISCARD auto restinio::http_field_parsers::transfer_encoding_value_t::make_parser | ( |  | ) |
| inline static

A factory function for a parser of Transfer-Encoding value.

Since
  v.0.6.9

Definition at line 107 of file transfer-encoding.hpp.

## ◆ try_parse()

static RESTINIO_NODISCARD expected_t< transfer_encoding_value_t, restinio::easy_parser::parse_error_t > restinio::http_field_parsers::transfer_encoding_value_t::try_parse | ( | string_view_t | what | ) |
| inline static

An attempt to parse Transfer-Encoding HTTP-field.

Since
  v.0.6.9

Definition at line 143 of file transfer-encoding.hpp.

## Member Data Documentation

## ◆ values

value_container_t restinio::http_field_parsers::transfer_encoding_value_t::values

Definition at line 98 of file transfer-encoding.hpp.

The documentation for this struct was generated from the following file:

- restinio/helpers/http_field_parsers/transfer-encoding.hpp